package sampleCode2;
import java.util.*;
import java.net.*;

abstract class URLProcessor {
        //constants that specify web addresses
        final String EAST_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/east_privileged.html";
        final String EAST_NOT_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/east_notprivileged.html";
        final String WEST_MEMBER_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/west_member_privileged.html";
        final String WEST_MEMBER_NOT_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/west_member_notprivileged.html";
        final String WEST_NONMEMBER_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/west_nonmember_privileged.html";
        final String WEST_NONMEMBER_NOT_PRIVILEGED = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/west_nonmember_notprivileged.html"; 
        final String OTHER_REGION = "http://www.kdsi.net/~pcorazza/javaWorldArticleHTML/other_region.html"; 
        
        URLProcessor(){
        }
        
        DataBank db;
        
        /** this is the value that must be set by decideURL() */
        URL url;
        
        DataBank getDb() {
            return db;
        }
        
        void setDb(DataBank databank) {
            db = databank;
        }
        
        URL getUrl() {
            return url;
        }
        
        /**
         *  This method receives one of the partial urls given
         *  as constants for this class, and creates a full url 
         *  from it, and sets it in the url variable
         */
        void setUrl(String s) {
            try {
                url = new URL(s);
            }
            catch(MalformedURLException e) {
                System.out.println(s + " is not one of the initially given filenames");
            }
                        
        }
        /** this is the central method that is implemented in the subclasses */        
        abstract void decideUrl();
        
}
        
        
        
        

