package logic;

import java.util.*;

public class ConditionSequencer {
    
    Vector conditions;

    public ConditionSequencer(Vector conditions) {
        this.conditions = conditions;
    }
    
    public void addCondition(Condition c, int position) throws RuleNotFoundException {
        if(conditions == null){
            throw new RuleNotFoundException("A null conditions Vector was passed into ConditionSequencer");
        }
        if(position >= conditions.capacity()) {
            throw new RuleNotFoundException("An attempt was made to insert a condition in a position that exceeds the condition Vector's capacity.");
        }
        conditions.insertElementAt(c, position);
    }
}